

public class Ball extends Entity {
  
  public float dir;
  public boolean ballLost;
  
  public Ball(float x, float y, float dir) {
    this.x = x;
    this.y = y;
    this.dir = dir;
    speed = 2;
    ballLost = false;
    xa = sin(radians(dir))*speed;
    ya = cos(radians(dir))*speed;
    fric = 1;
    size = 8;
    tex = 4;
  }
  
  public void update() {
    if(x < 0) {
      x = 0;
      xa=-xa;
    }
    if(x+size > width/SCALE) {
      x = width/SCALE-size;
      xa=-xa;
    }
    if(y < 0) {
      y = 0;
      ya=-ya;
    }
    if(y > height/SCALE) {
      ballLost = true;
    }
    super.update();
    if(ballLost == true) {
      resetBall();
    }
  }
  
  public void collide(Entity entity) {
    if(entity instanceof EnemyEntity) {
      ((EnemyEntity)entity).damage(2);
    }
    if(entity instanceof Player) {
      y = entity.y-size;
      ya=-ya;
      score+=5;
    }
    if(entity instanceof Bullet) {
      entity.removed = true;
    }
  }
  
  public void resetBall() {
    ballLost = false;
    score -= 25;
    this.dir = random(60)+15+(90*int(random(4)));
    xa = sin(radians(dir))*speed;
    ya = cos(radians(dir))*speed;
    x = width/SCALE/2;
    y = height/SCALE/2;
  }
}
